//--- トップページ用パララックス
const browserType = document.querySelector('html').dataset.browseMode;
const loadElm = document.querySelector('.top-mv');
const parentElm = document.querySelectorAll('.block-parallax');
const textContElm = document.querySelectorAll('.block-content-wrap');
const childElm = document.querySelectorAll('.parallax-inner:not(.auto-playback):not(.js-prllx-bg)');
let firstCount = 0;

// --------------- パララックス終了監視
const endParallax = document.querySelector('.block-parallax-end');
const endHeader = document.querySelector('.pane-header');
let endCount = 0;
const fadeInOptions2 = {
  root: null,
  rootMargin: '0px',
  threshold: 0.1,
};
const observer2 = new IntersectionObserver((entries, observer) => {
  entries.forEach(entry => {
    if (entry.isIntersecting) {
      document.querySelector('.pane-header').style.transform = '';
      endHeader.classList.add('active');
      observer2.unobserve(entry.target);
      endCount++;
    }
  });
}, fadeInOptions2);

  observer2.observe(endParallax);

// --------------- SPのみ：テキストコンテント監視
  const innerText = document.querySelectorAll('.text-content .is-text');
  const fadeInOptions3 = {
    root: null,
    rootMargin: '-35%',
  };
  const Options3Threshold = 1.0;
  const parallaxOptions3Threshold = 0.8;
  const observer3 = new IntersectionObserver((entries, observer) => {
    entries.forEach(entry => {
      if (entry.isIntersecting) {
        entry.target.closest('.block-content-wrap').querySelector('.block-fixed-cart').classList.add('active');
      } else {
        entry.target.closest('.block-content-wrap').querySelector('.block-fixed-cart').classList.remove('active');
      }
    });
  }, fadeInOptions3);

// --------------- 親要素監視
const fadeInOptions = {
  root: null,
  rootMargin: '0px',
  threshold: 0.2,
};
const fadeInObserver = new IntersectionObserver((entries, observer) => {
  const getFirstElm = entries;
  entries.forEach((entry) => {
    if (entry.isIntersecting) {

      // ヘッダー表示対応
      // if(entry.target === childElm[0] && !entry.target.classList.contains('already')) {
      //     resizeObserver.observe(itemHeader);
      // }

      // 表示するとき
      entry.target.classList.add('active');
      addClassWithDelay(entry.target);
      
      // 初回表示時
      if(entry.target.classList.contains('parallax-inner')) {
        entry.target.classList.add('already');
      }
      
      // また見るとき
      if(endCount > 0) {
        observer2.observe(endParallax);
        endHeader.classList.remove('active');
        endCount = 0;

        // const headerH = itemHeader.clientHeight;
        // if(document.querySelector('.pane-header:not(.active)')) document.querySelector('.pane-header:not(.active)').style.transform = 'translateY(calc(-100% + '+ headerH +'px))';
      }

      // ヘッダー表示対応（追従後）
      if(entry.target === document.querySelector('.top-mv+.block-parallax .parallax-inner:not(.js-prllx-bg)')) {
          if(entry.target.classList.contains('active')) {
              console.log('childActive');
              // const headerH = itemHeader.clientHeight;
              document.querySelector('.pane-header:not(.active)').style.transform = 'translateY(calc(-100% + '+ headerH +'px))';
          }
      }

    } else {
      entry.target.classList.remove('active');
      if(!entry.target.classList.contains('point-list') && browserType === 'S') {
        document.querySelector('body').classList.remove('is-fixed');
      }

      if(entry.target === document.querySelector('.top-mv+.block-parallax .parallax-inner:not(.js-prllx-bg)')) {
          if(!entry.target.classList.contains('active') && document.querySelector('.top-mv+.block-parallax.active')) {
              console.log('childHide');
              setTimeout(()=>{
                document.querySelector('.pane-header:not(.active)').style.transform = '';
              },100);
          }
      }
    }
  });
}, fadeInOptions);

// --------------- 初期表示（自動再生）
const actions = [
  { delay: 0, selector: '.js-prllx-bg' },
  { delay: 1500, selector: '.poition-bg'},
  { delay: 200, selector: '.auto-playback'}
];
async function addClassWithDelay(target) {
  for (const action of actions) {
    await new Promise((resolve) => setTimeout(resolve, action.delay));
    target.querySelector(action.selector)?.classList.add('active');
  }
}

// --------------- リサイズ監視
// const mvBgImg = document.querySelector('.main-read .bg-inner img');
// const mvLogoImg = document.querySelector('.main-read .poition-bg');
// const mvCoverImg = document.querySelector('.main-read .position-img-elm.positoin-img img');
// const itemHeader = document.querySelector('.item-detail-header');
const resizeObserver = new ResizeObserver(entries => {
  for (const entry of entries) {
    // MV:画像リサイズ
    /*if (entry.target === mvBgImg) {
      const natureWidth = entry.target.naturalWidth;
      const natureHeight = entry.target.naturalHeight;
      const orgGcd = gcd(natureWidth,natureHeight);
      const orgRatio_h = natureHeight / orgGcd;

      // 縦幅
      const setHeight = (entry.contentRect.height / orgRatio_h) * 2.8;
      mvCoverImg.style.height = setHeight + 'px';

      // 位置
      const setPosHeight = (entry.contentRect.height / orgRatio_h) * 3;
      mvCoverImg.parentNode.style.bottom = setPosHeight + 'px';

      // 位置2
      // const setLogoPosHeight = (entry.contentRect.height / orgRatio_h) * 5.5;
      // mvLogoImg.style.bottom = setLogoPosHeight + 'px';
    }*/
    // if (entry.target === itemHeader) {
    //   const headerH = itemHeader.clientHeight;
    //   if(document.querySelector('.pane-header:not(.active)')) document.querySelector('.pane-header:not(.active)').style.transform = 'translateY(calc(-100% + '+ headerH +'px))';
    // }
  }
});
function gcd(x, y){
  if(y === 0) return x
  return gcd(y, x % y)
}

const targets = document.querySelectorAll('.parallax-inner');
const options = {
  root: null,
  rootMargin: '0px',
  threshold: 0.25
};
const observer = new IntersectionObserver(intersect, options);
setTimeout(() => {
  targets.forEach(target => {
    observer.observe(target);
  });
}, 1500);

function intersect(entries) {
  entries.forEach(entry => {
    if (entry.isIntersecting) {
      entry.target.classList.add('is-inview');
    }
  });
}

jQuery('.more-campaign').on('click', function () {
  jQuery('.fl-banner-modal').fadeIn();
});

jQuery('.fl-banner-modal,.fl-banner-modal-inner .modal-close').on('click', function () {
  jQuery('.fl-banner-modal').fadeOut();
});

jQuery('.fl-banner-modal-inner').on('click', function (e) {
  e.stopPropagation();
});

// --------------- 初期表示
// document.querySelector('body').classList.add('is-fixed');

// --------------- ローディング画面
window.addEventListener('load', () => {
  /*setTimeout(function() {*/
    // document.querySelector('.top-mv').classList.add('hide');
    // document.querySelector('.main-read').classList.add('mv-anime');
    // document.querySelector('.fl-banner').classList.add('mv-anime');
    // document.querySelector('body').classList.remove('is-fixed');

    // 発火
    // parentElm.forEach((elm) => fadeInObserver.observe(elm,{
    //   attributes: true,
    //   childList: true
    // }));
    // childElm.forEach((elm) => fadeInObserver.observe(elm,{
    //   attributes: true,
    //   childList: true
    // }));

    /*if (browserType === 'S') {
      innerText.forEach((elm) => {
        const threshold = elm.closest('.main-read') ? parallaxOptions3Threshold : Options3Threshold;
        observer3.observe(elm,{
          attributes: true,
          childList: true,
          threshold: threshold,
        });
      });
    }*/
  /*}, 2000);*/
});


//--- 活躍する理由
function handleInteraction(event) {
  let listItem = event.currentTarget;

  //初期化
  Array.from(featureList.getElementsByTagName('li')).forEach(function (item) {
    item.classList.remove('disabled');
  });

  // ホバーまたはクリックしているli要素にactiveクラスを追加
  listItem.classList.add('active');

  // ホバーまたはクリックしていないli要素からactiveクラスを削除
  Array.from(listItem.parentElement.children).forEach(function (item) {
    if (item !== listItem) {
      item.classList.remove('active');
    }
  });

  // ホバーまたはクリックしていないli要素にdisabledクラスを追加
  Array.from(listItem.parentElement.children).forEach(function (item) {
    if (item !== listItem) {
      item.classList.add('disabled');
    }
  });
}

function handleDisable() {
  // activeのliをクリック時、初期化する
  Array.from(featureList.getElementsByTagName('li')).forEach(function (item) {
    item.classList.remove('active', 'hidden');
  });
}

function handleMouseLeave() {
  // マウスが離れたときに全てのli要素からactiveクラスとdisabledクラスを削除
  Array.from(featureList.getElementsByTagName('li')).forEach(function (item) {
    item.classList.remove('active', 'disabled');
  });
}

let featureList = document.getElementById('js-feature-link');
let listItems = featureList.getElementsByTagName('li');

// if (browserType === 'S') {
//   // SPのとき
//   Array.from(listItems).forEach(function (item) {
//     item.addEventListener('click', function(event) {
//       handleInteraction(event);
//     });
//   });
//   // listItems.addEventListener('click', function(e) {
//   //   // "active" クラスを持っている場合
//   //   if(e.target.classList.contains('active')) {
//   //     // すべての li から "active" クラスを削除
//   //     listItems.forEach(function(li) {
//   //       li.classList.remove('active', 'hidden');
//   //     });
//   //   }
//   // });
// } else {
//   // PCのときホバー
//   Array.from(listItems).forEach(function (item) {
//     item.addEventListener('mouseover', handleInteraction);
//     item.addEventListener('mouseleave', handleMouseLeave);
//   });
// }

jQuery('.fl-banner .close').click(function(){
  jQuery(this).parent('.fl-banner').addClass('hide');
});

//--- loading
// var bar = new ProgressBar.Line(splash_text, {
//   strokeWidth: 0.2,
//   easing: 'easeInOut',
//   duration: 3000,
//   color: '#ffffffa6',
//   trailColor: '#555',
//   trailWidth: 0.1,
//   svgStyle: {width: '100%', height: '100%'}
// });

//アニメーションスタート
// bar.animate(1.0, function () {
//   //アニメーションが終わったら
//   jQuery("#splash").delay(500).fadeOut(800);
//   jQuery('.top-mv').delay(1000).addClass('mv-anime');
// });  

//--- フローティングバナーの透過
function ScrollTransparentFnc() {

  let scroll = jQuery(window).scrollTop();
  let banner = jQuery('.fl-banner');

  if( banner.length) {
    if (scroll > 100) {
      banner.addClass('fade')
    } else {
      banner.removeClass('fade')
    }
  }
}
// jQuery(window).scroll(function () {
//   ScrollTransparentFnc();
// });